<?php

/*

version 1.00
Created by MakeJar https://www.makejar.com/

*/

include 'config.php';
include 'includes/faucethub.php';

session_start();

$action = '';

if (isset($_POST['act'])) {
    $action = $_POST['act'];
}

// load session
if ((isset($_SESSION['FH_API_KEY'])) && (!empty($_SESSION['FH_API_KEY']))) {
    $settings['FH_API_KEY'] = $_SESSION['FH_API_KEY'];
}

switch ($action) {
    case 'login':
        // Login with FH session API KEY
        if ((isset($_POST['FH_API_KEY'])) && (!empty($_POST['FH_API_KEY']))) {
            $_SESSION['FH_API_KEY'] = $_POST['FH_API_KEY'];
        }
        header('Location: .');
        exit;
    break;
    case 'logout':
        // Logout
        $_SESSION = array();
        header('Location: .');
        exit;
    break;
    case 'send':
        // Send
        $BTC_ADDRESS = $_POST['BTC_ADDRESS'];
        $BTC = $_POST['BTC'];
        $_SESSION['result'] = '';

        if (!empty($settings['FH_API_KEY'])) {
          $fh_class = new FaucetHub($settings['FH_API_KEY']);
          $response = $fh_class->send($BTC_ADDRESS, $BTC);
          if ((isset($response)) && (is_array($response))) {
              $response['BTC_ADDRESS'] = $BTC_ADDRESS;
              $response['BTC'] = $BTC;
              $_SESSION['result'] = $response;
              if (isset($response['balance'])) {
                  $_SESSION['FH_BALANCE'] = $response['balance'];
              }
          } else {
              $_SESSION['result'] = 'Connection lost. Check the faucethub.io if the transaction was successful.';
          }
        }
        header('Location: .');
        exit;
    break;
}

// load USD/BTC rate
if ((!isset($_SESSION['USD_BTC_RATE'])) || ($_SESSION['USD_BTC_RATE_TIME']<time()-3600)) {
    $btc_json_data = file_get_contents('https://api.coingecko.com/api/v3/coins/bitcoin?localization=en&sparkline=false');
    $btc_data = json_decode($btc_json_data, true);
    if (isset($btc_data['market_data']['current_price']['usd'])) {
      $_SESSION['USD_BTC_RATE'] = $btc_data['market_data']['current_price']['usd'];
      $_SESSION['USD_BTC_RATE_TIME'] = time();
    }
}

// load FH balance
if ((empty($_SESSION['FH_BALANCE'])) && (!empty($settings['FH_API_KEY']))) {
    $fh_class = new FaucetHub($settings['FH_API_KEY']);
    $response = $fh_class->getBalance();
    if ((isset($response)) && (is_array($response)) && ($response['status']==200)) {
        $_SESSION['FH_BALANCE'] = $response['balance'];
    }
}

?>
<html>
<head>
<style>
* {
    font-family: verdana;
    font-size: 12px;
}

#id_BTC {
  background-color:#EEFFEE;
}

.status_error {
    color:#AA0000;
}
.status_success {
    color:#009900;
}
</style>
<script src="js/jquery-3.3.1.min.js" type="text/javascript"></script>
<script type="text/javascript">
$(function() {
    var USD_BTC_RATE = <?php echo (float)$_SESSION['USD_BTC_RATE']; ?>;
    $('#id_form').on('submit', function() {
        if (($('#id_BTC_ADDRESS').val()=='') || ($('#id_BTC').val()=='0')) {
          return false;
        }
    });
    $('#id_rate_USD_BTC').html((Math.round(USD_BTC_RATE*100)/100)+' USD/BTC');
    $('#id_rate_BTC_USD').html((Math.round((1/USD_BTC_RATE)*100000000)/100000000)+' BTC/USD');
    $('#id_rate_satoshi_USD').html((Math.round((1/USD_BTC_RATE)*100000000))+' satoshi/USD');
    $('#id_USD,#id_FEE').on('change keyup', function() {
        var USD_value = 0;
        var result = 0;
        if ((!isNaN($('#id_USD').val())) && ($('#id_USD').val())) {
            USD_value = parseFloat($('#id_USD').val());
            result = USD_value*((1/USD_BTC_RATE)*100000000);
            if ((!isNaN($('#id_FEE').val())) && ($('#id_FEE').val())) {
                var fee = parseFloat($('#id_FEE').val());
                result = result - (result*fee/100);
            }
            result = Math.round(result);
        }
        $('#id_BTC').val(result);
    });
    $('#id_BTC').on('change keyup', function() {
        var BTC_value = 0;
        var result = 0;
        if ((!isNaN($('#id_BTC').val())) && ($('#id_BTC').val())) {
            USD_value = parseFloat($('#id_BTC').val());
            result = USD_value*(USD_BTC_RATE/100000000);
            if ((!isNaN($('#id_FEE').val())) && ($('#id_FEE').val())) {
                var fee = parseFloat($('#id_FEE').val());
                result = result + (result*fee/100);
            }
            result = Math.round(result*100)/100;
        }
        $('#id_USD').val(result);
    });
});
</script>
</head>
<body>
<?php
if (empty($settings['FH_API_KEY'])) {
    // ask for FH API KEY
    ?>
    <form action="." method="post" id="id_form_login">
        <input type="hidden" name="act" value="login" />
        FH API KEY:<br />
        <input type="password" name="FH_API_KEY" size="64" /><br />
        <input type="submit" value="login" />
    </form>
<?php
} else {
    ?>
    <form action="." method="post" id="id_form_logout">
      <input type="hidden" name="act" value="logout" />
      <input type="submit" value="Logout" />
    </form>
    <form action="." method="post" id="id_form">
        <input type="hidden" name="act" value="send" />
        <small>
          <b>Rate (coingecko.com):</b><br />
          &nbsp; <span id="id_rate_USD_BTC"></span><br />
          &nbsp; <span id="id_rate_BTC_USD"></span><br />
          &nbsp; <span id="id_rate_satoshi_USD"></span><br />
          <br />
<?php
    if (isset($_SESSION['FH_BALANCE'])) {
        echo '<b>Balance:</b> '.$_SESSION['FH_BALANCE'].' satoshi<br />';
    }
    ?>
        </small>
        <hr />
        <b>Send</b><br />
        BTC Address:<br />
        <input type="text" name="BTC_ADDRESS" id="id_BTC_ADDRESS" size="64" autocomplete="off" /><br />
        Value in USD:<br />
        <input type="text" name="USD" id="id_USD" size="6" value="0" /><br />
        Fee %:<br />
        <input type="text" name="FEE" id="id_FEE" size="4" value="<?php echo $settings['USD_BTC_FEE']; ?>" /><br />
        Value in satoshi (BTC):<br />
        <input type="text" name="BTC" id="id_BTC" size="9" value="0" /><br />
        <br />
        <input type="submit" value="Send" />
<?php
    if ((isset($_SESSION['result'])) && (!empty($_SESSION['result']))) {
        if (is_array($_SESSION['result'])) {
            echo '<br /><br />';
            if ((isset($_SESSION['result']['success'])) && ($_SESSION['result']['success']==1)) {
                echo '<span class="status_success">';
                echo '<b>'.$_SESSION['result']['html'].'</b>';
                echo $_SESSION['result']['BTC_ADDRESS'].'<br />';
                echo $_SESSION['result']['BTC'].' satoshi<br />';
                echo '</span>';
            } else {
                echo '<span class="status_error">';
                echo '<b>'.$_SESSION['result']['html'].'</b>';
                echo $_SESSION['result']['BTC_ADDRESS'].'<br />';
                echo $_SESSION['result']['BTC'].' satoshi<br />';
                echo '</span>';
            }
        } else {
            // string
            echo '<b class="status_error">'.$_SESSION['result'].'</b>';
        }
    }
?>
    </form>
<?php
}
?>
</body>
</html>